org.apache.http.nio.protocol

## Class ThrottlingHttpServiceHandler

- java.lang.Object
- - org.apache.http.nio.protocol.NHttpHandlerBase
  - - org.apache.http.nio.protocol.ThrottlingHttpServiceHandler

- All Implemented Interfaces:
    NHttpServiceHandler

  Deprecated.
  (4.2) use `HttpAsyncService`

      @Deprecated
      @ThreadSafe
      public class ThrottlingHttpServiceHandler
      extends NHttpHandlerBase
      implements NHttpServiceHandler

  Service protocol handler implementation that provide compatibility with the blocking I/O by utilizing shared content buffers and a fairly small pool of worker threads. The throttling protocol handler allocates input / output buffers of a constant length upon initialization and controls the rate of I/O events in order to ensure those content buffers do not ever get overflown. This helps ensure nearly constant memory footprint for HTTP connections and avoid the out of memory condition while streaming content in and out. The `HttpRequestHandler.handle(HttpRequest, HttpResponse, HttpContext)` method will fire immediately when a message is received. The protocol handler delegate the task of processing requests and generating response content to an `Executor`, which is expected to perform those tasks using dedicated worker threads in order to avoid blocking the I/O thread.

  Usually throttling protocol handlers need only a modest number of worker threads, much fewer than the number of concurrent connections. If the length of the message is smaller or about the size of the shared content buffer worker thread will just store content in the buffer and terminate almost immediately without blocking. The I/O dispatch thread in its turn will take care of sending out the buffered content asynchronously. The worker thread will have to block only when processing large messages and the shared buffer fills up. It is generally advisable to allocate shared buffers of a size of an average content body for optimal performance.

  The following parameters can be used to customize the behavior of this class:

  - `NIOReactorPNames.CONTENT_BUFFER_SIZE`
  - `CoreProtocolPNames.WAIT_FOR_CONTINUE`
  Since:
    4.0

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected Executor` | `executor` Deprecated.
    `protected HttpExpectationVerifier` | `expectationVerifier` Deprecated.
    `protected HttpRequestHandlerResolver` | `handlerResolver` Deprecated.
    `protected HttpResponseFactory` | `responseFactory` Deprecated.

    - ### Fields inherited from class org.apache.http.nio.protocol.NHttpHandlerBase

      `allocator, CONN_STATE, connStrategy, eventListener, httpProcessor, params`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `ThrottlingHttpServiceHandler(HttpProcessor httpProcessor, HttpResponseFactory responseFactory, ConnectionReuseStrategy connStrategy, ByteBufferAllocator allocator, Executor executor, HttpParams params)` Deprecated.
    `ThrottlingHttpServiceHandler(HttpProcessor httpProcessor, HttpResponseFactory responseFactory, ConnectionReuseStrategy connStrategy, Executor executor, HttpParams params)` Deprecated.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `closed(NHttpServerConnection conn)` Deprecated. Triggered when the connection is closed.
    `void` | `connected(NHttpServerConnection conn)` Deprecated. Triggered when a new incoming connection is created.
    `void` | `exception(NHttpServerConnection conn, HttpException httpex)` Deprecated. Triggered when an HTTP protocol violation occurs while receiving an HTTP request.
    `void` | `exception(NHttpServerConnection conn, IOException ex)` Deprecated. Triggered when an I/O error occurs while reading from or writing to the underlying channel.
    `void` | `inputReady(NHttpServerConnection conn, ContentDecoder decoder)` Deprecated. Triggered when the underlying channel is ready for reading a new portion of the request entity through the corresponding content decoder.
    `void` | `outputReady(NHttpServerConnection conn, ContentEncoder encoder)` Deprecated. Triggered when the underlying channel is ready for writing a next portion of the response entity through the corresponding content encoder.
    `void` | `requestReceived(NHttpServerConnection conn)` Deprecated. Triggered when a new HTTP request is received.
    `void` | `responseReady(NHttpServerConnection conn)` Deprecated. Triggered when the connection is ready to accept a new HTTP response.
    `void` | `setExpectationVerifier(HttpExpectationVerifier expectationVerifier)` Deprecated.
    `void` | `setHandlerResolver(HttpRequestHandlerResolver handlerResolver)` Deprecated.
    `protected void` | `shutdownConnection(NHttpConnection conn, Throwable cause)` Deprecated.
    `void` | `timeout(NHttpServerConnection conn)` Deprecated. Triggered when no input is detected on this connection over the maximum period of inactivity.

    - ### Methods inherited from class org.apache.http.nio.protocol.NHttpHandlerBase

      `canResponseHaveBody, closeConnection, getParams, handleTimeout, setEventListener`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### responseFactory

          protected final HttpResponseFactory responseFactory

      Deprecated.

    - #### executor

          protected final Executor executor

      Deprecated.

    - #### handlerResolver

          protected HttpRequestHandlerResolver handlerResolver

      Deprecated.

    - #### expectationVerifier

          protected HttpExpectationVerifier expectationVerifier

      Deprecated.

  - ### Constructor Detail

    - #### ThrottlingHttpServiceHandler

          public ThrottlingHttpServiceHandler(HttpProcessor httpProcessor,
                                      HttpResponseFactory responseFactory,
                                      ConnectionReuseStrategy connStrategy,
                                      ByteBufferAllocator allocator,
                                      Executor executor,
                                      HttpParams params)

      Deprecated.

    - #### ThrottlingHttpServiceHandler

          public ThrottlingHttpServiceHandler(HttpProcessor httpProcessor,
                                      HttpResponseFactory responseFactory,
                                      ConnectionReuseStrategy connStrategy,
                                      Executor executor,
                                      HttpParams params)

      Deprecated.

  - ### Method Detail

    - #### setHandlerResolver

          public void setHandlerResolver(HttpRequestHandlerResolver handlerResolver)

      Deprecated.

    - #### setExpectationVerifier

          public void setExpectationVerifier(HttpExpectationVerifier expectationVerifier)

      Deprecated.

    - #### connected

          public void connected(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when a new incoming connection is created.
      Specified by:
        `connected` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - new incoming connection HTTP connection.

    - #### closed

          public void closed(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the connection is closed.
      Specified by:
        `closed` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - closed HTTP connection.

    - #### exception

          public void exception(NHttpServerConnection conn,
                       HttpException httpex)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when an HTTP protocol violation occurs while receiving an HTTP request.
      Specified by:
        `exception` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that caused an HTTP protocol violation
        `httpex` - HTTP protocol violation exception

    - #### exception

          public void exception(NHttpServerConnection conn,
                       IOException ex)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when an I/O error occurs while reading from or writing to the underlying channel.
      Specified by:
        `exception` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that caused an I/O error
        `ex` - I/O exception

    - #### timeout

          public void timeout(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when no input is detected on this connection over the maximum period of inactivity.
      Specified by:
        `timeout` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that caused timeout condition.

    - #### requestReceived

          public void requestReceived(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when a new HTTP request is received. The connection passed as a parameter to this method is guaranteed to return a valid HTTP request object.

      If the request received encloses a request entity this method will be followed a series of `NHttpServiceHandler.inputReady(NHttpServerConnection, ContentDecoder)` calls to transfer the request content.
      Specified by:
        `requestReceived` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that contains a new HTTP request
      See Also:
        `NHttpServerConnection`

    - #### inputReady

          public void inputReady(NHttpServerConnection conn,
                        ContentDecoder decoder)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the underlying channel is ready for reading a new portion of the request entity through the corresponding content decoder.

      If the content consumer is unable to process the incoming content, input event notifications can be temporarily suspended using `IOControl` interface.
      Specified by:
        `inputReady` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that can produce a new portion of the incoming request content.
        `decoder` - The content decoder to use to read content.
      See Also:
        `NHttpServerConnection`, `ContentDecoder`, `IOControl`

    - #### responseReady

          public void responseReady(NHttpServerConnection conn)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the connection is ready to accept a new HTTP response. The protocol handler does not have to submit a response if it is not ready.
      Specified by:
        `responseReady` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that contains an HTTP response
      See Also:
        `NHttpServerConnection`

    - #### outputReady

          public void outputReady(NHttpServerConnection conn,
                         ContentEncoder encoder)

      Deprecated.
      Description copied from interface: `NHttpServiceHandler`
      Triggered when the underlying channel is ready for writing a next portion of the response entity through the corresponding content encoder.

      If the content producer is unable to generate the outgoing content, output event notifications can be temporarily suspended using `IOControl` interface.
      Specified by:
        `outputReady` in interface `NHttpServiceHandler`
      Parameters:
        `conn` - HTTP connection that can accommodate a new portion of the outgoing response content.
        `encoder` - The content encoder to use to write content.
      See Also:
        `NHttpServerConnection`, `ContentEncoder`, `IOControl`

    - #### shutdownConnection

          protected void shutdownConnection(NHttpConnection conn,
                                Throwable cause)

      Deprecated.
      Overrides:
        `shutdownConnection` in class `NHttpHandlerBase`

Copyright © 2005–2013 The Apache Software Foundation. All rights reserved.